package dao

import (
	"enterprise/common/model"
	"fmt"
	"gorm.io/gorm"
)

type ExternalCorpOrder struct {
}

func NewExternalCorpOrder() *ExternalCorpOrder {
	return &ExternalCorpOrder{}
}

func (d *ExternalCorpOrder) TableName() string {
	return "cp_order"
}

func (d *ExternalCorpOrder) QueryOwnerData(owner string, startTime, endTime int64, status int) ([]*model.ExternalCorpOrder, error) {
	orderTable := d.TableName()
	tx := corpDB.Table(orderTable)

	var o []*model.ExternalCorpOrder

	if status != 0 {
		tx.Where(orderTable+".status = ?", status)
	}
	tx.Where("cp_user.username = ?", owner)
	tx.Where(orderTable+".pay_time >= ?", startTime)
	tx.Where(orderTable+".pay_time <= ?", endTime)

	tx.Joins(fmt.Sprintf("LEFT JOIN cp_user ON %s.admin_id=cp_user.id", orderTable))
	tx.Where("cp_user.username = ?", owner)
	tx = tx.Find(&o)
	if tx.Error == gorm.ErrRecordNotFound {
		return o, nil
	}

	if tx.Error != nil {
		return nil, tx.Error
	}
	return o, nil
}
